module("luci.controller.radicale",package.seeall)
local a=require("nixio")
local l=require("nixio.fs")
local i=require("luci.dispatcher")
local n=require("luci.http")
local e=require("luci.i18n")
local r=require("luci.model.ipkg")
local d=require("luci.util")
local s=require("luci.sys")
local t="radicale"
local o="1.1"
local u=[[/usr/bin/radicale --version]]
local c="luci-app-radicale"
local h=e.translate("Radicale CalDAV/CardDAV Server")
local m="1.1.0-1"
function index()
entry({"admin","services","radicale"},alias("admin","services","radicale","edit"),_("CalDAV/CardDAV"),58).acl_depends={"luci-app-radicale"}
entry({"admin","services","radicale","edit"},cbi("radicale")).leaf=true
entry({"admin","services","radicale","logview"},call("_logread")).leaf=true
entry({"admin","services","radicale","startstop"},post("_startstop")).leaf=true
entry({"admin","services","radicale","status"},call("_status")).leaf=true
end
function app_description()
return e.translate("The Radicale Project is a complete CalDAV (calendar) and CardDAV (contact) server solution.")..[[<br />]]
..e.translate("Calendars and address books are available for both local and remote access, possibly limited through authentication policies.")..[[<br />]]
..e.translate("They can be viewed and edited by calendar and contact clients on mobile phones or computers.")
end
function app_title_main()
return[[<a href="javascript:alert(']]
..e.translate("Version Information")
..[[\n\n]]..c
..[[\n\t]]..e.translate("Version")..[[:\t]]..m
..[[\n\n]]..t..[[ ]]..e.translate("required")..[[:]]
..[[\n\t]]..e.translate("Version")..[[:\t]]
..o..[[ ]]..e.translate("or higher")
..[[\n\n]]..t..[[ ]]..e.translate("installed")..[[:]]
..[[\n\t]]..e.translate("Version")..[[:\t]]
..(service_version()or e.translate("NOT installed"))
..[[\n\n]]
..[[')">]]
..e.translate(h)
..[[</a>]]
end
function app_title_back()
return[[<a href="]]
..i.build_url("admin","services","radicale")
..[[">]]
..e.translate(h)
..[[</a>]]
end
function app_err_value()
if not service_version()then
return[[<h3><strong><br /><font color="red">&#160;&#160;&#160;&#160;]]
..e.translate("Software package '%s' is not installed."%t)
..[[</font><br /><br />&#160;&#160;&#160;&#160;&#160;&#160;]]
..e.translate("required")..[[: ]]..t..[[ ]]..o
..[[<br /><br />&#160;&#160;&#160;&#160;]]
..[[<a href="]]..i.build_url("admin","system","packages")..[[">]]
..e.translate("Please install current version !")
..[[</a><br />&#160;</strong></h3>]]
else
return[[<h3><strong><br /><font color="red">&#160;&#160;&#160;&#160;]]
..e.translate("Software package '%s' is outdated."%t)
..[[</font><br /><br />&#160;&#160;&#160;&#160;&#160;&#160;]]
..e.translate("installed")..[[: ]]..t..[[ ]]..service_version()
..[[<br />&#160;&#160;&#160;&#160;&#160;&#160;]]
..e.translate("required")..[[: ]]..t..[[ ]]..o
..[[<br /><br />&#160;&#160;&#160;&#160;]]
..[[<a href="]]..i.build_url("admin","system","packages")..[[">]]
..e.translate("Please update to current version !")
..[[</a><br />&#160;</strong></h3>]]
end
end
function service_version()
local e=nil
r.list_installed(t,function(a,t,a)
if t and(#t>0)then e=t end
end
)
if not e or(#e==0)then
e=d.exec(u)
if#e==0 then e=nil end
end
return e
end
function service_ok()
return r.compare_versions((service_version()or"0"),">=",o)
end
function _logread()
local e=UCI.cursor()
local t=e:get("radicale","radicale","logfile")or"/var/log/radicale"
e:unload("radicale")
local e=l.readfile(t)
if not e or#e==0 then
e="_nodata_"
end
n.write(e)
end
function _startstop()
local e=get_pid()
if e>0 then
s.call("/etc/init.d/radicale stop")
a.nanosleep(1)
if a.kill(e,0)then
a.kill(e,9)
end
e=0
else
s.call("/etc/init.d/radicale start")
a.nanosleep(1)
e=get_pid()
if e>0 and not a.kill(e,0)then
e=0
end
end
n.write(tostring(e))
end
function _status()
local e=get_pid()
n.write(tostring(e))
end
function get_pid()
return tonumber(s.exec([[ps | grep "[p]ython.*[r]adicale" 2>/dev/null | awk '{print $1}']]))or 0
end
function value_parse(e,i,d)
local t=e:formvalue(i)
local r=(t and(#t>0))
local n=e:cfgvalue(i)
local h=(e.rmempty or e.optional)
local o
if type(t)=="table"and type(n)=="table"then
o=(#t==#n)
if o then
for e=1,#t do
if n[e]~=t[e]then
o=false
end
end
end
if o then
t=n
end
end
local a,s=e:validate(t)
if not a then
if d then
return
end
if r then
e:add_error(i,"invalid",s)
return
elseif not h then
e:add_error(i,"missing",s)
return
elseif s then
e:add_error(i,"invalid",s)
return
end
end
o=(a==n)
local l=(a and(#a>0))and true or false
local d=(a==e.default)
if h and(not l or d)then
if e:remove(i)then
e.section.changed=true
end
return
end
if not e.forcewrite and o then
return
end
assert(a,"\n option: "..e.option..
"\n fvalue: "..tostring(t)..
"\n fexist: "..tostring(r)..
"\n cvalue: "..tostring(n)..
"\n vvalue: "..tostring(a)..
"\n vexist: "..tostring(l)..
"\n rm_opt: "..tostring(h)..
"\n eq_cfg: "..tostring(o)..
"\n eq_def: "..tostring(d)..
"\n errtxt: "..tostring(s))
if e:write(i,a)and not o then
e.section.changed=true
end
end
